package com.fp.persistence.parmas.param;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import java.lang.reflect.Field;

import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMREQUISITOPORTIPOTRAMITE*/
@Entity(name="TarmRequisitoPorTipoTramite")
@Table(name="TARMREQUISITOPORTIPOTRAMITE")
public class TarmRequisitoPorTipoTramite extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmRequisitoPorTipoTramite
*/
@EmbeddedId
private TarmRequisitoPorTipoTramiteKey pk;
@Column(name="DEPOSITOPORTRAMITE", nullable=true)

/**
* null
*/
private String depositoportramite;

@Column(name="DEPOSITOPORCUSTODIO", nullable=true)

/**
* null
*/
private String depositoporcustodio;

@Column(name="ACTIVE", nullable=true)

/**
* null
*/
private String active;

/**Contructor por defecto*/
public TarmRequisitoPorTipoTramite(){
}
/**Contructor de TarmRequisitoPorTipoTramite
@param pPk Clave Primaria del entity
*/
public TarmRequisitoPorTipoTramite(TarmRequisitoPorTipoTramiteKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmRequisitoPorTipoTramite
*/
public static TarmRequisitoPorTipoTramite find(EntityManager pEntityManager,TarmRequisitoPorTipoTramiteKey pKey) throws Exception{
    TarmRequisitoPorTipoTramite obj = pEntityManager.find(TarmRequisitoPorTipoTramite.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmRequisitoPorTipoTramite
@return El objeto que referencia a la Clave primaria de TarmRequisitoPorTipoTramite
*/
public TarmRequisitoPorTipoTramiteKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmRequisitoPorTipoTramite
@param pPk El objeto que referencia a la nueva Clave primaria de TarmRequisitoPorTipoTramite
*/
public void setPk(TarmRequisitoPorTipoTramiteKey pPk){
  pk=pPk;
}
/**Obtiene el valor de depositoportramite
@return valor de depositoportramite*/
public String getDepositoportramite(){
  return depositoportramite;
}
/**Fija el valor de depositoportramite
@param pDepositoportramite nuevo Valor de depositoportramite*/
public void setDepositoportramite(String pDepositoportramite){
  depositoportramite=pDepositoportramite;
}

/**Obtiene el valor de depositoporcustodio
@return valor de depositoporcustodio*/
public String getDepositoporcustodio(){
  return depositoporcustodio;
}
/**Fija el valor de depositoporcustodio
@param pDepositoporcustodio nuevo Valor de depositoporcustodio*/
public void setDepositoporcustodio(String pDepositoporcustodio){
  depositoporcustodio=pDepositoporcustodio;
}

/**Obtiene el valor de active
@return valor de active*/
public String getActive() {
	return active;
}

/**Fija el valor de active
@param pActive nuevo Valor de active*/
public void setActive(String pActive) {
	this.active = pActive;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmRequisitoPorTipoTramite))return false;
    TarmRequisitoPorTipoTramite that = (TarmRequisitoPorTipoTramite) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmRequisitoPorTipoTramite
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmRequisitoPorTipoTramite
*/
public Object createInstance(){
 TarmRequisitoPorTipoTramite instance=new TarmRequisitoPorTipoTramite();	
 instance.setPk(new TarmRequisitoPorTipoTramiteKey());
 return instance;
}
/**Clona la entidad TarmRequisitoPorTipoTramite
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmRequisitoPorTipoTramite p=(TarmRequisitoPorTipoTramite)this.clone();
  p.setPk((TarmRequisitoPorTipoTramiteKey)this.pk.cloneMe());
  return p;
}
}
